
var action = "save";
var tableData = undefined;
var tableOther = undefined;
var SUPPLIER_INVOICE_ID = undefined;
const TOKEN = Math.floor(Math.random() * 212345);
$(document).ready(function () {
    $('.status_btn').hide();
    $('#tblGRNAttachment').DataTable({
        responsive: true,
        "order": [],
        "columns": [
            { "data": "file" },
            { "data": "view" },
            { "data": "download" },
            { "data": "delete" },
        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },
        ],
    });



    $('#btnAttachment').on('click', function () {
        $('#attachmentAddModal').modal('toggle');
        //showWarningMessage('Please save purchase order to before upload attachmnet...!');
    });

    var supplierChooser = $('#supplierChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
        ],
        columnDefs: [
            { width: 200, targets: 0 },
            { width: 300, targets: 1 },
        ],
    });

    var supplier_data = allSuppliers();
    console.log(supplier_data);
    supplierChooser.setDataSource(supplier_data);


    supplierChooser.on('select', function (event, data) {
        $('#txtSupplier').val(data[1]);
        $('#txtSupplier').attr("data-id", data[0]);
        var input = supplierChooser.getInput();
        input.focus();

        //getPoFromSupplier(data[0]);
    });




    var productChooser = $('#productChooser').dataChooser({
        "columns": [
            { "data": "id" },
            { "data": "value0" },
            { "data": "value1" },
        ],
        columnDefs: [
            { width: 50, targets: 0 },
            { width: 200, targets: 1 },
            { width: 300, targets: 2 },
        ],
    });

    var product_data = allProduct();
    console.log(product_data);
    productChooser.setDataSource(product_data);

    $('#attachmnet_token').val(TOKEN);


    tableData = $('#tblData').transactionTable({
        thead: ['grn_data_id', 'internal_id', 'external_id', 'ProductPrimaryID', 'ProductID', 'Product Name', 'Unit', 'Qty', 'Price', 'Discount', 'Discount', 'Value', 'Remove'],
        data_chooser: [{ 'col': 5 }],
        chooser: productChooser,
        column_def: { 1: 100 },
        auto_focus: 5,
        row_type: [
            { 'type': 'hidden', 'value': '0', 'align': 'left', 'width': '100px' },
            { 'type': 'hidden', 'value': '0', 'align': 'left', 'width': '100px' },
            { 'type': 'hidden', 'value': '', 'align': 'left', 'width': '100px' },
            { 'type': 'hidden', 'value': '', 'align': 'left', 'width': '100px' },
            { 'type': 'string', 'value': '', 'align': 'left', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'left', 'width': '100%' },
            {
                'type': 'select', 'value': [], 'align': 'left', 'width': '100px'
            },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            {
                'type': 'select', 'value': [], 'align': 'left', 'width': '100px'
            },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'string', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'remove', 'value': 'X', 'align': 'center', 'width': '50px' }],
    });



    tableOther = $('#tblOther').transactionTable({
        thead: ['', 'Description', 'Quantity', 'Price', 'Discount', 'Value', 'Remove'],
        //data_chooser: [{ 'col': 1 }],
        //chooser : supplerChooser,
        //column_def: { 1: 200, 2: 200 },
        auto_focus: 0,
        row_type: [
            { 'type': 'text', 'value': '', 'align': 'left', 'width': '100%' },
            { 'type': 'text', 'value': '', 'align': 'left', 'width': '100%' },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'text', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'text', 'value': '0', 'align': 'right', 'width': '100px' },
            { 'type': 'string', 'value': '', 'align': 'right', 'width': '100px' },
            { 'type': 'remove', 'value': 'X', 'align': 'center', 'width': '50px' }],
    });




    productChooser.on('select', function (event, data) {
        var selected_row = tableData.getSelectedRow();
        var cells = selected_row.getElementsByTagName('td');
        cells[3].childNodes[0].value = data[0];
        cells[4].childNodes[0].value = data[1];
        cells[5].childNodes[0].value = data[2];
        var input = productChooser.getInput();
        input.focus();

        var product_id = data[0];
        var uom = getProduct_Uom(product_id);
        $('#' + cells[6].childNodes[0].id).empty();
        $('#' + cells[6].childNodes[0].id).append('<option value="' + uom.id + '">' + uom.value + '</option>');
        $('#' + cells[9].childNodes[0].id).empty();
        $('#' + cells[9].childNodes[0].id).append('<option value="1">%</option>');
        $('#' + cells[9].childNodes[0].id).append('<option value="2">Amount</option>');
    });




    $('input[name="trans_date"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }

    });


    $('input[name="deliverBeforeDate"]').daterangepicker({
        singleDatePicker: true,
        showDropdowns: true,
        locale: {
            format: 'YYYY-MM-DD',
        }

    });

    //allEmployees();
    //allStores();
    newReferanceID();



    $('#btnSave').on('click', function () {


        if ($(this).text() == 'Save') {
            saveSupplierInvoice();
        } else {
            //if (!isApproved()) {
            updateSupplierInvoice();
            //} else {
            //showWarningMessage('This grn has been approved,Cannot be update...!');
            // }
        }
    });




    if (window.location.search.length > 0) {
        var sPageURL = window.location.search.substring(1);
        var param = sPageURL.split('?');
        var id = param[0].split('=')[1].split('&')[0];
        action = param[0].split('=')[2].split('&')[0];
        SUPPLIER_INVOICE_ID = id;
        getSupplierInvoice(id);
        if (action == 'edit') {
            $('#btnSave').text('Update');
            $('.status_btn').hide();
        } else if (action == 'view') {
            $('#btnSave').hide();
            $('.status_btn').show();
        }

    } else {
        tableData.add_empty_row();
        tableOther.add_empty_row();
        transactionTimeout(60000);//5MINUTES
    }



    $('#txtSupplier').on('input', function () {
        supplierChooser.showChooser($('#txtSupplier'));
    });


    $('#txtDiscountPresentage').on('input', function () {
        overallCalculation();
    });


    $('#btnApproveGrn').on('click', function () {
        change_status_confirmation(SUPPLIER_INVOICE_ID, 1, "Are you sure want to approve?");
    });
    $('#btnRejectGrn').on('click', function () {
        change_status_confirmation(SUPPLIER_INVOICE_ID, 2, "Are you sure want to reject?");
    });


});



Dropzone.options.myDropzone = {
    dictDefaultMessage: 'Drop file here or click to upload!!!!!!!!',
    addRemoveLinks: true,
    init: function () {
        this.on("complete", function (file) {
            allAttachment(1, TOKEN);
        });
    }
};




function allEmployees() {
    $.ajax({
        type: "GET",
        url: "/sc/grnHeaderController/allEmployees",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            //$('#txtReceivedBy').setData(res);
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}






function allStores() {
    $.ajax({
        type: "GET",
        url: "/sc/grnHeaderController/allStores",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            for (var i = 0; i < res.length; i++) {
                $('#cmbStores').append('<option value="' + res[i].id + '">' + res[i].name + '</option>');
            }
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}






function newReferanceID() {
    var referanceID = newID("/fm/SupplierInvoiceController/referanceMaxID");
    $('#txtExternal_id').val(referanceID);
}






function allProduct() {
    var product_data = [];
    $.ajax({
        type: "GET",
        url: "/fm/SupplierInvoiceController/allProduct",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            product_data = response.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });

    return product_data;
}




function allSuppliers() {
    var supplier_data = [];
    $.ajax({
        type: "GET",
        url: "/fm/SupplierInvoiceController/allSuppliers",
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            supplier_data = response.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
    return supplier_data;
}




function saveSupplierInvoice() {

    newReferanceID();
    if ($('#txtSupplier').attr("data-id") == '' || $('#txtSupplier').val() == '') {
        showWarningMessage("Please Select Supplier");
        return;
    }
    var supplier_invoice_data = {};
    var supplier_invoice_data_arr = tableData.dataSource();
    if (supplier_invoice_data_arr.length == 0) {
        showWarningMessage("Invalied Grn (Empty list)");
        return;
    }
    for (var i = 0; i < supplier_invoice_data_arr.length; i++) {
        if (!supplier_invoice_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        supplier_invoice_data[i] = JSON.stringify({ "grn_data_id": supplier_invoice_data_arr[i][0], "grn_internal_id": supplier_invoice_data_arr[i][1], "grn_external_id": supplier_invoice_data_arr[i][2], "product_id": supplier_invoice_data_arr[i][3], "product_name": supplier_invoice_data_arr[i][5], "unit_id": supplier_invoice_data_arr[i][6], "qty": supplier_invoice_data_arr[i][7], "price": supplier_invoice_data_arr[i][8], "discount_id": supplier_invoice_data_arr[i][9], "discount": supplier_invoice_data_arr[i][10], "value": supplier_invoice_data_arr[i][11], });
    }


    var supplier_invoice_other = {};
    var other_arr = tableOther.dataSource();
    for (var i = 0; i < other_arr.length; i++) {
        supplier_invoice_other[i] = { "description": other_arr[i][1], "quantity": other_arr[i][2], "price": other_arr[i][3], "discount": other_arr[i][4], "value": other_arr[i][5], };
    }


    $.ajax({
        type: "POST",
        url: '/fm/SupplierInvoiceController/save',
        async: false,
        data: {
            'external_id': $('#txtExternal_id').val(),
            'ref_extenal_id': $('#txtExternal_id').val(),
            'trans_date': $('#txtGrnDate').val(),
            'supplier_id': $('#txtSupplier').attr("data-id"),
            'supplier_ref_no': $('#txtSupplierRefNo').val(),
            'attachment_token': TOKEN,
            'supplier_invoice_data': supplier_invoice_data,
            'supplier_invoice_other': supplier_invoice_other,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success('data saved');
                location.href = '/fm/supplier_invoice';
            } else {
                showErrorMessage();
            }
            //location.reload();

        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
        }

    });
}



function getSupplierInvoice(id) {
    $.ajax({
        type: "GET",
        url: "/fm/SupplierInvoiceController/getSupplierInvoice/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {
            progress(true);
        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            SUPPLIER_INVOICE_ID = res.internal_id
            referanceID = res.external_id;
            $('#txtExternal_id').val(res.external_id);
            $('#txtGrnDate').val(res.trans_date);
            $('#txtSupplier').attr("data-id", res.supplier_Id);
            $('#txtSupplier').val(res.supplier);
            $('#txtSupplierRefNo').val(res.supplier_ref_no);

            var request_data = res.data;
            for (var i = 0; i < request_data.length; i++) {
                var grn_data_id = request_data[i].grn_data_id;
                var grn_internal_id = request_data[i].grn_internal_id;
                var grn_external_id = request_data[i].grn_external_id;
		console.log(request_data[i].price);
                tableData.addRow(
                    [
                        { 'type': 'hidden', 'val': grn_data_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'hidden', 'val': grn_internal_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'hidden', 'val': grn_external_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'hidden', 'val': request_data[i].product_primary_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'string', 'val': request_data[i].product_id, 'align': 'left', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].product, 'align': 'left', 'width': '100%' },
                        {
                            'type': 'select', 'val': request_data[i].uom, 'align': 'left', 'width': '100px'
                        },
                        { 'type': 'text', 'val': request_data[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_data[i].price, 'align': 'right', 'width': '100px' },
                        {
                            'type': 'select', 'val': request_data[i].discount_type, 'align': 'left', 'width': '100px'
                        },
                        { 'type': 'text', 'val': request_data[i].discount, 'align': 'right', 'width': '100px' },
                        { 'type': 'string', 'val': request_data[i].value, 'align': 'right', 'width': '100px' },
                        { 'type': 'remove', 'val': 'X', 'align': 'center', 'width': '50px' }]
                );

                var selected_row = tableData.getSelectedRow();
                var cells = selected_row.getElementsByTagName('td');
                setSelectedOption(cells[9].childNodes[0].id, request_data[i].discount_id);
            }



            var request_other = res.request_other;
            console.log(request_other);
            for (var i = 0; i < request_other.length; i++) {
                tableOther.addRow(
                    [
                        { 'type': 'text', 'val': '', 'align': 'left', 'width': '100%' },
                        { 'type': 'text', 'val': request_other[i].description, 'align': 'left', 'width': '100%' },
                        { 'type': 'text', 'val': request_other[i].quantity, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_other[i].price, 'align': 'right', 'width': '100px' },
                        { 'type': 'text', 'val': request_other[i].discount, 'align': 'right', 'width': '100px' },
                        { 'type': 'string', 'val': request_other[i].value, 'align': 'right', 'width': '100px' },
                        { 'type': 'remove', 'val': 'X', 'align': 'center', 'width': '50px' }]
                );
            }

            allAttachment(id, 0);

        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {
            progress(false);
        }

    });
}






function updateSupplierInvoice() {

    if ($('#txtSupplier').attr("data-id") == '' || $('#txtSupplier').val() == '') {
        showWarningMessage("Please Select Supplier");
        return;
    }
    var supplier_invoice_data = {};
    var supplier_invoice_data_arr = tableData.dataSource();
    if (supplier_invoice_data_arr.length == 0) {
        showWarningMessage("Invalied Grn (Empty list)");
        return;
    }
    for (var i = 0; i < supplier_invoice_data_arr.length; i++) {
        if (!supplier_invoice_data_arr[i][0]) {
            showWarningMessage("You shuld fill empty row in The list");
            return;
        }
        supplier_invoice_data[i] = JSON.stringify({ "grn_data_id": supplier_invoice_data_arr[i][0], "grn_internal_id": supplier_invoice_data_arr[i][1], "grn_external_id": supplier_invoice_data_arr[i][2], "product_id": supplier_invoice_data_arr[i][3], "product_name": supplier_invoice_data_arr[i][5], "unit_id": supplier_invoice_data_arr[i][6], "qty": supplier_invoice_data_arr[i][7], "price": supplier_invoice_data_arr[i][8], "discount_id": supplier_invoice_data_arr[i][9], "discount": supplier_invoice_data_arr[i][10], "value": supplier_invoice_data_arr[i][11], });
    }


    var supplier_invoice_other = {};
    var other_arr = tableOther.dataSource();
    for (var i = 0; i < other_arr.length; i++) {
        supplier_invoice_other[i] = { "description": other_arr[i][1], "quantity": other_arr[i][2], "price": other_arr[i][3], "discount": other_arr[i][4], "value": other_arr[i][5], };
    }


    if (SUPPLIER_INVOICE_ID == undefined) {
        showWarningMessage("Supplier's invoice not selected...!");
        return;
    }


    $.ajax({
        type: "PUT",
        url: '/fm/SupplierInvoiceController/update/' + SUPPLIER_INVOICE_ID,
        data: {
            'external_id': $('#txtExternal_id').val(),
            'ref_extenal_id': $('#txtExternal_id').val(),
            'trans_date': $('#txtGrnDate').val(),
            'supplier_id': $('#txtSupplier').attr("data-id"),
            'supplier_ref_no': $('#txtSupplierRefNo').val(),
            'attachment_token': TOKEN,
            'supplier_invoice_data': supplier_invoice_data,
            'supplier_invoice_other': supplier_invoice_other,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            $('#btnSave').html('<i class="fa fa-circle-o-notch fa-spin"></i>');
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                toastr.success('data updated');
                location.href = '/fm/supplier_invoice_list';
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
        }

    });
}





function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}


function triggerRowInputs(id, selected_row) {

    if (id == "tblOther") {
        var cells = selected_row.getElementsByTagName('td');
        var quantity = $('#' + cells[2].childNodes[0].id);
        var price = $('#' + cells[3].childNodes[0].id);
        var discount = $('#' + cells[4].childNodes[0].id);
        var value = $('#' + cells[5].childNodes[0].id);
        quantity.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            var amount = (qty * prc);
            var disc_amount = (amount * disc) / 100.0;
            var val = (amount - disc_amount);
            if (!isNaN(val)) {
                value.val(val);
            }
            overallCalculation();

        });
        price.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            var amount = (qty * prc);
            var disc_amount = (amount * disc) / 100.0;
            var val = (amount - disc_amount);
            if (!isNaN(val)) {
                value.val(val);
            }
            overallCalculation();
        });
        discount.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            if (isNaN(disc)) {
                disc = 0;
            }
            if (isNaN(qty)) {
                qty = 0;
            }
            if (isNaN(prc)) {
                prc = 0;
            }
            var amount = (qty * prc);
            var disc_amount = (amount * disc) / 100.0;
            var val = (amount - disc_amount);
            if (!isNaN(val)) {
                value.val(val);
            }
            overallCalculation();
        });
    } else if (id == "tblData") {
        var cells = selected_row.getElementsByTagName('td');
        var quantity = $('#' + cells[7].childNodes[0].id);
        var price = $('#' + cells[8].childNodes[0].id);
        var discount_type = $('#' + cells[9].childNodes[0].id);
        var discount = $('#' + cells[10].childNodes[0].id);
        var value = $('#' + cells[11].childNodes[0].id);
        quantity.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            if (isNaN(disc)) {
                disc = 0;
            }
            if (isNaN(qty)) {
                qty = 0;
            }
            if (isNaN(prc)) {
                prc = 0;
            }
            var amount = (qty * prc);
            if (discount_type.val() == 1) {
                var disc_amount = (amount * disc) / 100.0;
                var val = (amount - disc_amount);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            } else {
                var val = (amount - disc);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            }
        });
        price.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            if (isNaN(disc)) {
                disc = 0;
            }
            if (isNaN(qty)) {
                qty = 0;
            }
            if (isNaN(prc)) {
                prc = 0;
            }
            var amount = (qty * prc);
            if (discount_type.val() == 1) {
                var disc_amount = (amount * disc) / 100.0;
                var val = (amount - disc_amount);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            } else {
                var val = (amount - disc);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            }
        });
        discount.on('input', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            if (isNaN(disc)) {
                disc = 0;
            }
            if (isNaN(qty)) {
                qty = 0;
            }
            if (isNaN(prc)) {
                prc = 0;
            }
            var amount = (qty * prc);

            if (discount_type.val() == 1) {
                var disc_amount = (amount * disc) / 100.0;
                var val = (amount - disc_amount);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            } else {
                var val = (amount - disc);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            }
        });
        discount_type.on('change', function () {
            var qty = parseFloat(quantity.val());
            var prc = parseFloat(price.val());
            var disc = parseFloat(discount.val());
            if (isNaN(disc)) {
                disc = 0;
            }
            if (isNaN(qty)) {
                qty = 0;
            }
            if (isNaN(prc)) {
                prc = 0;
            }
            var amount = (qty * prc);
            value.val(amount);

            if (discount_type.val() == 1) {
                var disc_amount = (amount * disc) / 100.0;
                var val = (amount - disc_amount);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            } else {
                var val = (amount - disc);
                if (!isNaN(val)) {
                    value.val(val);
                } else {
                    value.val(0);
                }
            }
        });
    }

}


function change(event, id) {



}


function rowKeyTyped(id) {

    //calculateValue(id);

}



function calculateValue(id) {
    var quantity = parseFloat($('#tblData_row_' + id + '__col_4_text').val());
    var price = parseFloat($('#tblData_row_' + id + '__col_5_text').val());
    var discount_type = $('#tblData_row_' + id + '__col_6_select').val();
    var discount = parseFloat($('#tblData_row_' + id + '__col_7_text').val());

    if (isNaN(discount)) {
        discount = 0;
    }


    $('#tblData_row_' + id + '__col_6_select').on('change', function () {
        $('#tblData_row_' + id + '__col_7_text').val('');
        $('#tblData_row_' + id + '__col_8_string').val(0);
    });

    if (isNaN(discount)) {
        discount = 0;
    }
    if (discount_type == 1) {
        var disc = ((quantity * price) / 100.0) * discount;
        var val = (quantity * price) - parseFloat(disc);
        if (isNaN(val)) {
            val = 0;
        }
        $('#tblData_row_' + id + '__col_8_string').val(parseFloat(val).toFixed(2));
    } else {
        var val = (quantity * price) - discount;
        if (isNaN(val)) {
            val = 0;
        }
        $('#tblData_row_' + id + '__col_8_string').val(parseFloat(val).toFixed(2));
    }
}




function transactionTableUpdate(table_id) { // override function from transaction_table.js


}



function getProduct_Uom(id) {

    var unit = undefined;
    $.ajax({
        type: "GET",
        url: "/sc/grnHeaderController/getUom/" + id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            unit = response.data.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
    return unit;
}



function isApproved() {

    var bool = false;
    $.ajax({
        type: "GET",
        url: "/sc/grnHeaderController/isApproved/" + SUPPLIER_INVOICE_ID,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            bool = response.data.result;
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
    return bool;

}



function transactionTimeout(minutes) {

    setInterval(function () {
        if (tableData.getTransactionDelay() > minutes) {
            tableData.reset();
        }
    }, minutes);
}



function allAttachment(supplier_invoice_id, token) {
    $.ajax({
        type: "GET",
        url: "/fm/SupplierInvoiceController/allAttachment/" + supplier_invoice_id + "/" + token,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                for (var i = 0; i < result.length; i++) {
                    var path = "'" + result[i].path + "'";
                    var id = "'" + result[i].purchase_order_attachment_id + "'";
                    data.push({
                        "file": result[i].path,
                        "view": '<button type= "button" class="btn btn-primary" onclick="viewAttachment(' + path + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "download": '<button type= "button" class="btn btn-success" onclick="downloadAttachment(' + path + ');"><i class="fa fa-download" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteAttachment(' + id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#tblGRNAttachment').DataTable();
                //table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}


function viewAttachment(file) {
    window.open('/finance/' + file);

}


function downloadAttachment(file) {
    var link = document.createElement("a");
    link.download = file;
    link.href = "/finance/" + file;
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);
    delete link;
}


function getPoFromSupplier(id) {

    $.ajax({
        type: "GET",
        url: "/sc/grnHeaderController/getPoFromSupplier/" + id,
        async: false,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            var res = response.data.result;
            for (var i = 0; i < res.length; i++) {
                $('#cmbPoNo').append('<option value="' + res[i].external_id + '">' + res[i].external_id + '</option>');
            }
        },
        error: function (error) {
            console.log(error);


        },
        complete: function () {

        }

    });
}

function change_status_confirmation(id, status, msg) {
    swal({
        title: msg,
        //text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: {
            yes: {
                text: "Yes",
                value: true,
                className: 'btn btn-danger',
            },
            no: {
                text: "No",
                value: false,
                className: 'btn btn-primary',
            }
        },

    })
        .then((willDelete) => {
            if (willDelete) {



                var supplier_invoice_data = {};
                var supplier_invoice_data_arr = tableData.dataSource();
                for (var i = 0; i < supplier_invoice_data_arr.length; i++) {
                    supplier_invoice_data[i] = JSON.stringify({ "grn_data_id": supplier_invoice_data_arr[i][0], "grn_internal_id": supplier_invoice_data_arr[i][1], "grn_external_id": supplier_invoice_data_arr[i][2], "product_id": supplier_invoice_data_arr[i][3], "product_name": supplier_invoice_data_arr[i][5], "unit_id": supplier_invoice_data_arr[i][6], "qty": supplier_invoice_data_arr[i][7], "price": supplier_invoice_data_arr[i][8], "discount_id": supplier_invoice_data_arr[i][9], "discount": supplier_invoice_data_arr[i][10], "value": supplier_invoice_data_arr[i][11],"grn_document_no": 100 });
                }
                change_status(id, status, supplier_invoice_data);
            }
        });

}

function change_status(id, status, supplier_invoice_data) {

    $.ajax({
        type: "PUT",
        url: '/fm/SupplierInvoiceController/change_status/' + id,
        data: {
            status: status,
            supplier_invoice_data: supplier_invoice_data,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {
            // document.getElementById('btnApproveGrn').innerHTML = '<i class="fa fa-circle-o-notch fa-spin"></i>';
        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                if (status == 1) {
                    toastr.success("Supplier Invoice approved.");
                } else if (status == 2) {
                    toastr.success("Supplier Invoice rejected.");
                }

            } else {
                showErrorMessage();
            }
            location.href = '/fm/supplier_invoice_list';
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {
            // document.getElementById('approve'+id).innerHTML = '<i class="fa fa-times" aria-hidden="true"></i>';
        }

    });
}

function overallCalculation() {


    $('#tblData tr').each(function () {
        var qty = parseFloat($(this).find("td").eq(6).children().val());
        var price = parseFloat($(this).find("td").eq(7).children().val());
        var discount = parseFloat($(this).find("td").eq(8).children().val());

        if (!isNaN(qty) && !isNaN(price)) {
            gross_value += (qty * price);
        }

        if (!isNaN(qty) && !isNaN(price) && !isNaN(discount)) {
            discount_value += ((qty * price) * discount) / 100.0;
        }


    });
    $('#tblOther tr').each(function () {
        var qty = parseFloat($(this).find("td").eq(2).children().val());
        var price = parseFloat($(this).find("td").eq(3).children().val());
        var discount = parseFloat($(this).find("td").eq(4).children().val());

        if (!isNaN(qty) && !isNaN(price)) {
            gross_value += (qty * price);
        }

        if (!isNaN(qty) && !isNaN(price) && !isNaN(discount)) {
            discount_value += ((qty * price) * discount) / 100.0;
        }


    });



}



/**
* generateID
* This function is used to generate id
* @param id This is the paramter to require id
*/
function generateID(id) {

    let pattern = {
        1: "0000",
        2: "000",
        3: "00",
        4: "0",
    };
    var length = Math.ceil(Math.log(id + 1) / Math.LN10);
    return pattern[length] + id;
}



/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}